;###############################################################################
;###                                                                         ###
;###                                                                         ###
;###                                                                         ###
;###              Map-Loader v1.1 fr LevelED Maps fr Pure Basic            ###
;###                                                                         ###
;###                                                                         ###
;###                          written by Epyx 2003                           ###
;###                                                                         ###
;###                                                                         ###
;###                                                                         ###
;###                                                                         ###
;###                                                                         ###
;###############################################################################




Declare.s Map_Name()
Declare.s Map_Author()
Declare.s Map_Comment()
Declare.l Map_Load(FileName$)
Declare.w Map_LoadTiles(FileName$)  

Declare   Map_Info()
Declare.s Map_version()
Declare.s Map_TileSet()
Declare.b Map_TileSize()
Declare.w Map_XSize()
Declare.w Map_YSize()
Declare.b Map_ILayer()
Declare.w Map_GetTile(xpos.w,ypos.w,XOffset,YOffset)
Declare   Map_SetTile(xpos.w,ypos.w,Value.w)
Declare   Map_PaintTile(Code,Screen_X,Screen_Y)  
Declare   Map_Draw(Xpo,Ypo,XOffset,YOffset,Width,Height)
Declare.w Map_CountCode(Value.w)
Declare.s Map_SearchCode(Value.w)
Declare.l Map_GetXPos(Wert.s)
Declare.l Map_GetYPos(Wert.s)



#Sprite_Nummer=59999



Procedure.l Map_Load(FileName$)   
  
  Global Map_Ed$, Map_EdV$, Map_Tile_Size, Map_SizeX, Map_SizeY, Map_ItemLayer, Map_Var_sek, Map_Var_FPS
  Global Map_TileName$, Map_Title$, Map_Author$, Map_Comment$, Map_TileDotX, Map_TileDotY   

  
  x=OpenFile(0,FileName$)  
  
  
  Map_Ed$="" : For t=1 To 3 : A= ReadByte() : Map_Ed$=Map_Ed$+chr$(A):Next t


  
  Map_EdV$="": For t=1 To 4 : A= ReadByte() : Map_EdV$=Map_EdV$+chr$(A):Next t


  Map_Tile_Size = ReadByte() ; Map Tile gre einlesen
 

  ;### X Ausdehnung der Karte in Map_SizeX speichern
  A=0 : Size$="" : While (A<>13)
  A= ReadByte() : Size$=Size$+Chr(A)
  Wend : Map_SizeX= Val(Size$)


  ;### Y Ausdehnung der Karte in Map_SizeY speichern
  A=0 : Size$="" : While (A<>10) 
  A= ReadByte() : Size$=Size$+Chr(A)
  Wend : Map_SizeY= Val(Size$)



  Map_ItemLayer = ReadByte() ;### Item Layer einlesen


  A=0 : Size$="" : While (A<>10) 
  A= ReadByte() : Size$=Size$+Chr(A)
  Wend : Map_TileName$= Mid(Size$,1,Len(Size$)-1)


  A = ReadByte() ; ### Unused Byte - Future Features
  A = ReadByte() ; ### Unused Byte - Future Features


  ; Den Map Title auslesen    
  Map_Title$=""  : For t=1 To 20 : A= ReadByte() : Map_Title$=Map_Title$+chr$(A)    : Next t

  ; Den Map Author auslesen    
  Map_Author$="" : For t=1 To 20 : A= ReadByte() : Map_Author$=Map_Author$+chr$(A)  : Next t
  
  ;### Den Map Kommentar auslesen    
  Map_Comment$="": For t=1 To 20 : A= ReadByte() : Map_Comment$=Map_Comment$+chr$(A): Next t  
  
  
  ;### Map Daten in ein 2 Dimensionales Array sichern
  Dim Map.w(Map_SizeX,Map_SizeY)
  
  For MP_Y = 0 To Map_SizeY-1
     For MP_X = 0 To Map_SizeX-1
       Map_Xic=ReadByte()       
       If Map_Xic<0 : XL=(128) + (Map_Xic) : Map_Xic=128+XL : EndIf      
       Map.w(MP_X,MP_Y)= Map_Xic 
     Next MP_X
  Next MP_Y
  CloseFile(0)
  
  Map_Load.l = Lof()
  ProcedureReturn Map_Load.l

EndProcedure


Procedure Map_Info()

  If Map_ItemLayer=0 : Lay$="No" : Else : Lay$="Yes" : EndIf
  MSz=Map_SizeX*Map_SizeY

  TxT$=      "MapEd v1.0 Loader by Epyx"+ Chr(13)
  TxT$=TxT$+ " "+ Chr(13)+ Chr(13)

  TxT$=TxT$+ "Editor version: "+Map_Ed$+" v."+Mid(Map_EdV$,2,1)+"."+Mid(Map_EdV$,3,1)+ Chr(13)
  TxT$=TxT$+ "Loaded Map:   "+Map_Title$+Chr(13)+chr$(13)

  TxT$=TxT$+ "Map Tile Size:  "+Str(Map_Tile_Size)+Chr(13)  
  TxT$=TxT$+ "Used Tileset:   "+chr$(34)+Map_TileName$+chr$(34)+Chr(13)
  TxT$=TxT$+ "Map Size:       "+Str(Map_SizeX)+" * "+Str(Map_SizeY)+" - "+Str(MSz)+" Bytes"+Chr(13)  
  TxT$=TxT$+ "Use Item Layer: "+Lay$+Chr(13)+Chr(13)
  TxT$=TxT$+ "Map Author:   "+Map_Author$+Chr(13)
  TxT$=TxT$+ "Comment:       "+Map_Comment$+Chr(13)
  MessageRequester("MapEd Loader",TxT$, #MB_ICONINFORMATION)
EndProcedure


Procedure.w Map_GetTile(xxpos.w,yypos.w,XOffset,YOffset)
;#### Returns Tile number at Pos X And Y ####


 If xxpos>0 : xpos.w=Int(xxpos/Map_Tile_Size) +1 : Else : xpos.w=0 : EndIf
 If yypos>0 : ypos.w=Int(yypos/Map_Tile_Size)  : Else : ypos.w=Int(yypos/Map_Tile_Size) : EndIf
 ;ypos.w=Int(yypos/Map_Tile_Size) +1
 xpos = (xpos+XOffset)
 ypos = (ypos+YOffset)
 
 ;Debug Str(yypos)+" - "+Str(yypos.w)

 Map_GetTile.w= Map.w(xpos.w,ypos.w)
 ProcedureReturn Map_GetTile.w
EndProcedure


Procedure Map_SetTile(xpos.w,ypos.w,Value.w)
;#### Set Tile number at Pos X and Y ####
xpos.w : ypos.w+1
Map(xpos.w,ypos.w)= Value.w
EndProcedure


Procedure.w Map_LoadTiles(FileName$)  
;#### Die benutzen Tiles in ein Sprite laden ###
Map_LoadTiles.w= LoadSprite(#Sprite_Nummer, FileName$,0) 
Map_TileDotX=SpriteWidth(#Sprite_Nummer) : Map_TileDotY=SpriteHeight(#Sprite_Nummer) 
ProcedureReturn Map_LoadTiles.w
EndProcedure


Procedure Map_PaintTile(Code,Screen_X,Screen_Y)  
 ; Malt das Bild eines Tiles auf einen Bildschirm
  TX=Map_TileDotX : TY=Map_TileDotY 
  XO=0 : YO=0 : TSX=0 : TSY=0
  
     TSX=(TX/Map_Tile_Size) : TSY=(TY/Map_Tile_Size)
     YO=((Map_Tile_Size * Code)/TX)
     XO=(Code-(YO*TSX))-1
     If XO=-1 : XO=(TSX-1): YO-1 : : EndIf
     If YO=-1 : YO+1 : EndIf

  ClipSprite(#Sprite_Nummer,(XO*Map_Tile_size),(YO*Map_Tile_size),Map_Tile_size,Map_Tile_size)
  DisplaySprite(#Sprite_Nummer,Screen_X,Screen_Y)
EndProcedure



Procedure Map_Draw(Xpo,Ypo,XOffset,YOffset,Width,Height)
 
  TX=Map_TileDotX : TY=Map_TileDotY 
  EndY=(YOffset+Height) : EndX=(XOffset+Width)
  If EndY>Map_SizeY : EndY=Map_SizeY : EndIf
  If EndX>Map_SizeX : EndX=Map_SizeX : EndIf
   
  If YOffset<0 : YOffset=0 : EndIf 
   
  
   
 For RunY= YOffset To (EndY)
    For RunX = XOffset  To (EndX)
      Code=Map(RunX,RunY)
      If Code>1 
  
      TSX=(TX/Map_Tile_Size) : TSY=(TY/Map_Tile_Size)
      YO=((Map_Tile_Size * Code)/TX)
      XO=(Code-(YO*TSX))-1
     If XO=-1 : XO=(TSX-1): YO-1 : : EndIf
     If YO=-1 : YO+1 : EndIf
     ClipSprite(#Sprite_Nummer,(XO*Map_Tile_size),(YO*Map_Tile_size),Map_Tile_size,Map_Tile_size)
     DisplayTransparentSprite(#Sprite_Nummer,Xpo+(RuX*Map_Tile_Size),Ypo+(RuY*Map_Tile_Size))  

;     LBX= Xpo+(RuX*Map_Tile_Size)+2
;     LBY= Ypo+(RuY*Map_Tile_Size)+2
;     StartDrawing(ScreenOutput())  
;     DrawingMode(4) 
;     Box(LBX,LBY, 28, 28) 
;     StopDrawing() 
     
     EndIf     

          
     RuX+1
     Next RunX
  RuY+1 : RuX=0
  Next RunY  
EndProcedure




Procedure.s Map_FPS()
If Val(FormatDate("%ss", Date()))=Map_Var_sek 
   Map_Var_FPS+1 
Else 
   Map_FPS.s =Str(Map_Var_FPS) 
   Map_Var_FPS=0 
EndIf 
Map_Var_sek=Val(FormatDate("%ss", Date())) 

ProcedureReturn Map_FPS.s
EndProcedure





Procedure Map_Dump()
;### Gibt die Map Daten in einer Message Box aus ###
TxT$=""
  For Round_Y= 0 To 9 
      For Round_X = 0 To 9
         xM=Map_GetTile(Round_X,Round_Y,0,0)
         Txt$=Txt$+Str(xM)+", "
      Next Round_X
    Txt$=Txt$+Chr(13)
  Next Round_Y
  MessageRequester("MapEd Loader",TxT$, #MB_ICONINFORMATION)
EndProcedure



Procedure.s Map_Name()
;#### Returns the Name of a Map #########
Map_Name.s=Map_Title$
ProcedureReturn Map_Name.s
EndProcedure


Procedure.s Map_Author()
;#### Returns the Author of a Map #########
Map_Author.s=Map_Author$
ProcedureReturn Map_Author.s
EndProcedure


Procedure.s Map_Comment()
;#### Returns the Comment of a Map #########
Map_Comment.s=Map_Comment$
ProcedureReturn Map_Comment.s
EndProcedure


Procedure.s Map_version()
;#### Returns the version of a Map Editor ####
Map_version.s=Map_Ed$+" "+Mid(Map_EdV$,2,1)+"."+Mid(Map_EdV$,3,1)
ProcedureReturn Map_version.s
EndProcedure

Procedure.s Map_TileSet()
;#### Returns the Tile Set Name of a Map Editor ####
Map_TileSet.s= Map_TileName$
ProcedureReturn Map_TileSet.s
EndProcedure

Procedure.b Map_TileSize()
;#### Returns the Tile Size of a Map Editor ####
Map_TileSize.b= Map_Tile_Size
ProcedureReturn Map_TileSize.b
EndProcedure

Procedure.w Map_XSize()
;#### Returns the X Size of a Map ####
Map_XSize.w= Map_SizeX-1
ProcedureReturn Map_XSize.w
EndProcedure

Procedure.w Map_YSize()
;#### Returns the Y Size of a Map ####
Map_YSize.w= Map_SizeY-1
ProcedureReturn Map_YSize.w
EndProcedure

Procedure.b Map_ILayer()
;#### Returns Item Layer switch ####
Map_ILayer.b= Map_ItemLayer
ProcedureReturn Map_ILayer.b
EndProcedure

Procedure.w Map_CountCode(Value.w)
;#### Returns the count of a Item Code in the Map ####

If Value.w=0 : ProcedureReturn 0 : EndIf
  Anzahl=0
  For Round_Y= 0 To Map_SizeY
      For Round_X = 0 To Map_SizeX  
         xM= Map.w(Round_X,Round_Y)
      If xM= Value.w : Anzahl+1 : EndIf
              
      Next Round_X
  Next Round_Y
ProcedureReturn Anzahl
EndProcedure


Procedure.s Map_SearchCode(Value.w)
;#### Returns the count of a Item Code in the Map ####

If Value.w=0 : ProcedureReturn "0" : EndIf
  
   For Round_Y= 0 To Map_SizeY
      For Round_X = 0 To Map_SizeX  
         xM= Map.w(Round_X,Round_Y)
       If xM= Value.w 
          Back$= Str(Round_X)+","+Str(Round_Y)
       ProcedureReturn Back$ : EndIf
      Next Round_X
  Next Round_Y
ProcedureReturn "0"
EndProcedure

Procedure.l Map_GetXPos(Wert.s)
;#### Returns the XPos from the Map_SearchCode() Procedure
   Var.l= Val(StringField(Wert.s, 1, ","))
   ProcedureReturn Var.l
EndProcedure

Procedure.l Map_GetYPos(Wert.s)
;#### Returns the XPos from the Map_SearchCode() Procedure
   Var.l= Val(StringField(Wert.s, 2, ","))
   ProcedureReturn Var.l
EndProcedure

Procedure.w NewProc()
   CatchSprite(#Sprite_Nummer,?GFX1) 
   Map_TileDotX=SpriteWidth(#Sprite_Nummer) : Map_TileDotY=SpriteHeight(#Sprite_Nummer) 
EndProcedure










; ExecutableFormat=Shared Dll
; CursorPosition=144
; FirstLine=122
; Executable=C:\Eigene Dateien\Pure\Map Loader\Map.exe.dll
; EOF